module Bio.Util.Test where

import Bio.Util as U
import Bio.Util.TestBase

import qualified Data.ByteString.Lazy.Char8 as BC

tests :: [Test]
tests = [ T "BS lines replacement" prop_bs_lines
        , T "BS internal lines"    prop_bs_mylines
        ]

-- test the 'lines' that is going to be used
prop_bs_lines :: String -> Bool
prop_bs_lines xs = Prelude.lines xs == (map BC.unpack . U.lines . BC.pack) xs

-- test mylines, which may be used or not, depending on whether we detect the LBS bug
prop_bs_mylines :: String -> Bool
prop_bs_mylines xs = Prelude.lines xs == (map BC.unpack . mylines . BC.pack) xs
